clear;

a=inputdatalayer1;          %set the layer for interpolation

tline1='error distribution for layer 7 (without filtering)';   
tline2='error distribution for layer 7 (with filtering)';
cutedge=2;
ratio=5;
epsilon=0.05;
lowpass=1;
area=10;

xnum=65;
ynum=61;

for (i=1:xnum)
    for (k=1:ynum)
        f(i,k)=a((i-1)*ynum+k,3);
    end
end

for (i=1:xnum)
    for (k=1:ynum)
        if not(f(i,k)>=0)
            if (i>=60 || k>=60)
                if (i>=k)
                    f(i:xnum,:)=0;
                else
                    f(:,k:ynum)=0;
                end% % % 
            else
                f(i,k)=f(i,k-1);
            end
        end
    end
end

for (i=1:xnum)
    for (k=1:ynum)
        if (f(i,k)~=0)
            f_i_k(i,k)=f(i,k);
        end
    end
end

[xnum,ynum]=size(f_i_k);

siteX=ceil(xnum/area);
siteY=ceil(ynum/area);

f_backup=f_i_k(1+cutedge:xnum-cutedge,1+cutedge:ynum-cutedge);
xnum=xnum-2*cutedge;
ynum=ynum-2*cutedge;
%mesh(f_backup)
f_backup(min(siteX*area,xnum+1):siteX*area,min(siteY*area,ynum+1):siteX*area)=0;    

for i=1:siteX
    for j=1:siteY
        for x=1:area
            for y=1:area 
                fcal(i,j,(x-1)*area+y)=f_backup((i-1)*area+x,(j-1)*area+y);
            end       
        end
    end
end      

for i=1:siteX
    for j=1:siteY
        temp=fcal(i,j,:);
        temp2=temp(find(temp~=0));
        fmean(i,j)=mean(temp2);
        fvar(i,j)=var(temp2);
    end
end



X=[1:ratio:xnum-1 xnum];
Y=[1:ratio:ynum-1 ynum];
xi=length(X);
yi=length(Y);

[X,Y]=newinterp(f_backup,X,Y,epsilon);

xj=length(X);
yj=length(Y);

if (xj<yj)
    i=0;
    j=0;
    while (i<(yj-xj))
        j=j+1;
        k=find(X==j);
        if (size(k,2)==0)
            X=[X j];
            i=i+1;
        end
    end
else
    i=0;% % % 
    j=0;
    while (i<(xj-yj))
         j=j+1;
         k=find(Y==j);
        if (size(k,2)==0)
            Y=[Y j];
            i=i+1;
        end
    end  
end

siteX=ceil(xnum/area);
siteY=ceil(ynum/area);

xj=max(xj,yj);
yj=max(xj,yj);
datausej=xj^2;


 Xtemp=zeros(0,1);
 for i=1:xj
     [value,index]=min(X);
     Xtemp=[Xtemp value];
     X(index)=10000;
 end 

Ytemp=zeros(0,1);
for i=1:yj
    [value,index]=min(Y);
    Ytemp=[Ytemp value];
    Y(index)=10000;
end

X=Xtemp;
Y=Ytemp;
Z=f_backup(X,Y);

for i=1:xnum
    for j=1:ynum
        ZI(i,j)=interp2(X,Y,Z,i,j,'cubic');
    end
end

Zfft=fft2(ZI);

for i=lowpass+1:xnum-lowpass
   Zfft(i,:)=0;
end
for j=lowpass+1:ynum-lowpass
   Zfft(:,j)=0;
end

Zdfft=abs(ifft2(Zfft));

ZI(min(siteX*area,xnum+1):siteX*area,min(siteY*area,ynum+1):siteX*area)=0;

for i=1:siteX
    for j=1:siteY
        for x=1:area
            for y=1:area 
                ZIcal(i,j,(x-1)*area+y)=ZI((i-1)*area+x,(j-1)*area+y);
            end       
        end
    end
end        

for i=1:siteX
    for j=1:siteY
        temp=ZIcal(i,j,:);
        temp2=temp(find(temp~=0));
        ZImean(i,j)=mean(temp2);
        ZIvar(i,j)=var(temp2);
    end
end


errormean=abs(((ZImean(1:siteX,1:siteY)-fmean(1:siteX,1:siteY))./fmean(1:siteX,1:siteY)));
maxmean_unf=max(max(errormean));
meanmean_unf=mean(mean(errormean));

errorvar=abs((ZIvar(1:siteX,1:siteY)-fvar(1:siteX,1:siteY))./fmean(1:siteX,1:siteY));
maxvar_unf=max(max(errorvar));
meanvar_unf=mean(mean(errorvar));

Zdfft(min(siteX*area,xnum+1):siteX*area,min(siteY*area,ynum+1):siteX*area)=0;

for i=1:siteX
    for j=1:siteY
        for x=1:area
            for y=1:area 
                Zdfftcal(i,j,(x-1)*area+y)=Zdfft((i-1)*area+x,(j-1)*area+y);
            end       
        end
    end
end      

clear X,Y;
for i=1:xj
    for j=1:yj
        X(i,j)=Xtemp(i);
        Y(i,j)=Ytemp(j);
        Z(i,j)=f_backup(i,j);
    end
end

for i=1:siteX
    for j=1:siteY
        temp=Zdfftcal(i,j,:);
        temp2=temp(find(temp~=0));
        Zdfftmean(i,j)=mean(temp2);
        Zdfftvar(i,j)=var(temp2);
    end
end


errormean=abs(((Zdfftmean(1:siteX,1:siteY)-fmean(1:siteX,1:siteY))./fmean(1:siteX,1:siteY)));
maxmean_f=max(max(errormean));

meanmean_f=mean(mean(errormean));

errorvar=abs((Zdfftvar(1:siteX,1:siteY)-fvar(1:siteX,1:siteY))./fmean(1:siteX,1:siteY));
maxvar_f=max(max(errorvar));
meanvar_f=mean(mean(errorvar));

relvar=fvar(1:siteX,1:siteY)./fmean(1:siteX,1:siteY);
relvar_f=Zdfftvar(1:siteX,1:siteY)./Zdfftmean(1:siteX,1:siteY);
maxrelvar=max(max(relvar));
meanrelvar=mean(mean(relvar));
maxrelvar_f=max(max(relvar_f));
meanrelvar_f=mean(mean(relvar_f));

%fprintf('\n%6f/%6f %6f/%6f %6f/%6f %6f/%6f\n',maxmean_unf,meanmean_unf,maxvar_unf,meanvar_unf,maxmean_f,meanmean_f,maxvar_f,meanvar_f);
fprintf('mean error      variance error      relative_variance      relative_variance_est\n');
fprintf('\n%6f/%6f %6f/%6f %6f/%6f %6f/%6f\n',maxmean_f,meanmean_f,maxvar_f,meanvar_f,maxrelvar,meanrelvar,maxrelvar_f,meanrelvar_f);

% % % % for i=1:xnum
% % % %     for j=1:ynum
% % % %         histerror((i-1)*xnum+j)=error(i,j);
% % % %     end
% % % % end
% % % % x=0:0.005:0.1;
% % % % hist(histerror,x)
% % % % H=hist(histerror,x);
% % % % maxH=max(H);
% % % % text(0.03,0.9*maxH,tline2);
% % % % text(0.03,0.8*maxH,['mean error=',num2str(def*100),'%']);
% % % % text(0.03,0.7*maxH,['max error=',num2str(maxerror*100),'%']);
% % % % text(0.03,0.6*maxH,['error variance: ',num2str(var*100),'%']);
% % % % text(0.03,0.5*maxH,['error larger than 5%: ',num2str(sumV*100),'%']);
% % % %text(0.03,0.4*maxH,['sampling data: ',num2str(datauseratio*100),'%']);