clear;

a=inputdatalayer2;  %set the layer to calculate
layernum=2;


eps=0.1;	
lowpass=1;
cutedge=2;
xnum=65;
ynum=61;

area=10;

for (i=1:xnum)
    for (k=1:ynum)
        f(i,k)=a((i-1)*ynum+k,3);
    end
end

for (i=1:xnum)
    for (k=1:ynum)
        if not(f(i,k)>=0)
            if (i>=60 || k>=60)
                if (i>=k)
                    f(i:xnum,:)=0;
                else
                    f(:,k:ynum)=0;
                end 
            else
                f(i,k)=f(i,k-1);
            end
        end
    end
end

for (i=1:xnum)
    for (k=1:ynum)
        if (f(i,k)~=0)
            Z(i,k)=f(i,k);
        end
    end
end

[xnum,ynum]=size(Z);
Z=Z(1+cutedge:xnum-cutedge,1+cutedge:ynum-cutedge);
[xnum,ynum]=size(Z);

siteX=ceil(xnum/area);
siteY=ceil(ynum/area);

Z(min(siteX*area,xnum+1):siteX*area,min(siteY*area,ynum+1):siteX*area)=0;

for i=1:siteX
    for j=1:siteY
        for x=1:area
            for y=1:area 
                fcal(i,j,(x-1)*area+y)=Z((i-1)*area+x,(j-1)*area+y);
            end       
        end
    end
end        

for i=1:siteX
    for j=1:siteY
        temp=fcal(i,j,:);
        temp2=temp(find(temp~=0));
        fmean(i,j)=mean(temp2);
        fvar(i,j)=var(temp2);
    end
end


f=zeros(xnum,ynum);
f_interp1=zeros(size(f));
f_interp2=zeros(size(f));

ValleyPeakX;

for i=1:length(indexX)
    f(indexX(i),indexY(i))=Z(indexX(i),indexY(i));
end
    
f=f';
Z=Z';
temp=xnum;
xnum=ynum;
ynum=temp;

ValleyPeakX;

for i=1:length(indexX)
    f(indexX(i),indexY(i))=Z(indexX(i),indexY(i));
end

f=f';
Z=Z';
temp=xnum;
xnum=ynum;
ynum=temp;

f(1,:)=Z(1,1:ynum);
f(:,1)=Z(1:xnum,1);
f(xnum,:)=Z(xnum,1:ynum);
f(:,ynum)=Z(1:xnum,ynum);

[X,Y]=find(f>0);
datause=length(X)/xnum/ynum;

for i=1:xnum
    temp=f(i,:);
    Xi=find(temp>10);
    Yi=f(i,Xi);
    Xii=1:ynum;
    f_interp1(i,:)=interp1(Xi,Yi,Xii);
end

for i=1:ynum
    temp=f(:,i);
    Xi=find(temp>10);
    Yi=f(Xi,i);
    Xii=1:xnum;
    f_interp2(:,i)=interp1(Xi,Yi,Xii);
end

f=(f_interp1+f_interp2)/2;


f(min(siteX*area,xnum+1):siteX*area,min(siteY*area,ynum+1):siteX*area)=0;

for i=1:siteX
    for j=1:siteY
        for x=1:area
            for y=1:area 
                ZIcal(i,j,(x-1)*area+y)=f((i-1)*area+x,(j-1)*area+y);
            end       
        end
    end
end        

for i=1:siteX
    for j=1:siteY
        temp=ZIcal(i,j,:);
        temp2=temp(find(temp~=0));
        ZImean(i,j)=mean(temp2);
        ZIvar(i,j)=var(temp2);
    end
end


Zfft=fft2(f(1:xnum,1:ynum));

for i=lowpass+1:xnum-lowpass
   Zfft(i,:)=0;
end
for j=lowpass+1:ynum-lowpass
   Zfft(:,j)=0;
end

Zdfft=abs(ifft2(Zfft));

Zdfft(min(siteX*area,xnum+1):siteX*area,min(siteY*area,ynum+1):siteX*area)=0;

for i=1:siteX
    for j=1:siteY
        for x=1:area
            for y=1:area
                Zdfftcal(i,j,(x-1)*area+y)=Zdfft((i-1)*area+x,(j-1)*area+y);
            end       
        end
    end
end        

for i=1:siteX
    for j=1:siteY
        temp=Zdfftcal(i,j,:);
        temp2=temp(find(temp~=0));
        Zdfftmean(i,j)=mean(temp2);
        Zdfftvar(i,j)=var(temp2);
    end
end

error=abs((f(1:xnum,1:ynum)-Z(1:xnum,1:ynum))./Z(1:xnum,1:ynum));
meanerror_unf=mean(mean(error));
maxerror_unf=max(max(error));


error=abs((Zdfft(1:xnum,1:ynum)-Z(1:xnum,1:ynum))./Z(1:xnum,1:ynum));
meanerror_f=mean(mean(error));
maxerror_f=max(max(error));


[xnum,ynum]=size(Z);
errormean=abs(((ZImean-fmean)./fmean));
maxmean_unf=max(max(errormean));
meanmean_unf=mean(mean(errormean));

errorvar=abs((ZIvar-fvar)./fmean);
maxvar_unf=max(max(errorvar));
meanvar_unf=mean(mean(errorvar));


errormean=abs(((Zdfftmean-fmean)./fmean));
maxmean_f=max(max(errormean));
meanmean_f=mean(mean(errormean));

errorvar=abs((Zdfftvar-fvar)./fmean);
maxvar_f=max(max(errorvar));
meanvar_f=mean(mean(errorvar));

relvar=fvar./fmean;
relvar_unf=ZIvar./ZImean;
relvar_f=Zdfftvar./Zdfftmean;
maxrelvar=max(max(relvar));
meanrelvar=mean(mean(relvar));
maxrelvar_unf=max(max(relvar_unf));
meanrelvar_unf=mean(mean(relvar_unf));
maxrelvar_f=max(max(relvar_f));
meanrelvar_f=mean(mean(relvar_f));

fprintf('\nlayer:%d, epsilon=%6f\n',layernum,eps)
fprintf('datause=%6f, meanerror=%6f, maxerror=%6f\n', datause,meanerror_unf,maxerror_unf);
fprintf('mean error      variance error      relative_variance      relative_variance_est\n');
fprintf('%6f/%6f %6f/%6f %6f/%6f %6f/%6f\n',maxmean_unf,meanmean_unf,maxvar_unf,meanvar_unf,maxrelvar,meanrelvar,maxrelvar_unf,meanrelvar_unf);
%fprintf('%6f/%6f %6f/%6f %6f/%6f %6f/%6f\n',maxmean_f,meanmean_f,maxvar_f,meanvar_f,maxrelvar,meanrelvar,maxrelvar_f,meanrelvar_f);
