clear;

a=inputdatalayer6;      %Select layer and dataset
eps=0.1;                %Set minmum difference between peak and valley in neighbor; 0.1 corresponding to 10% in slides

xnum=60;
ynum=61;

for (i=1:xnum)
    for (k=1:ynum)
        f(i,k)=a((i-1)*ynum+k,3);
    end
end

for (i=1:xnum)
    for (k=1:ynum)
        if not(f(i,k)>=0)
            if (i>=60 || k>=60)
                if (i>=k)
                    f(i:xnum,:)=0;
                else
                    f(:,k:ynum)=0;
                end 
            else
                f(i,k)=f(i,k-1);
            end
        end
    end
end

for (i=1:xnum)
    for (k=1:ynum)
        if (f(i,k)~=0)
            Z(i,k)=f(i,k);
        end
    end
end

[xnum,ynum]=size(Z);




data_back=Z(2:xnum-1,:)-Z(3:xnum,:);
data_front=Z(2:xnum-1,:)-Z(1:xnum-2,:);
data_distance=data_back.*data_front;
[indexX,indexY]=find(data_distance>0);

indexX=indexX+1;
indexXrecord=indexX;

i=2;

while (i<length(indexX))
    if (indexY(i)==indexY(i-1))
        if (abs((Z(indexX(i),indexY(i))-Z(indexX(i-1),indexY(i-1)))/Z(indexX(i),indexY(i)))<eps)
            if ( (abs( (Z(indexX(i),indexY(i))-Z(indexX(i+1),indexY(i+1)))/Z(indexX(i),indexY(i)))<eps) & (indexY(i)==indexY(i+1)))        
                indexX=[indexX(1:i-1);indexX(i+2:length(indexX))];
                indexY=[indexY(1:i-1);indexY(i+2:length(indexY))];
                i=i+1;
            else
                indexX=[indexX(1:i-2);indexX(i+1:length(indexX))];
                indexY=[indexY(1:i-2);indexY(i+1:length(indexY))];
            end
        else
            i=i+1;
        end
    else
        i=i+1;
    end
end


edgedist=ones(0,1);
nonedgedist=ones(0,1);

for i=1:ynum
    tempindex=find(indexY==i);
    edgedist=[edgedist;indexX(tempindex(1))-1;xnum-indexX(tempindex(length(tempindex)))];
    tempnonedge=indexX(tempindex(3:length(tempindex)-1))-indexX(tempindex(2:length(tempindex)-2));
    nonedgedist=[nonedgedist;tempnonedge];
end

figure(1)
x=min(edgedist):max(edgedist);
hist(edgedist,x);
title('edge distance distribution');
figure(2)
x=min(nonedgedist):max(nonedgedist);
hist(nonedgedist,x);
title('non-edge distance distribution');