% Copyright  2005-2006 The Regents of the University of California
% All Rights Reserved.
% 
% Permission to use, copy, modify, and distribute this software and its
% documentation for educational, research and non-profit purposes, without
% fee, and without a written agreement is hereby granted, provided that the
% above copyright notice, this paragraph and the following three paragraphs
% appear in all copies.
% 
% Permission to incorporate this software into commercial products may be
% obtained by contacting the University of California, Los Angeles, by
% sending email to lhe@ee.ucla.edu.
% 
% This software program and documentation are copyrighted by The Regents of
% the University of California. The software program and documentation are
% supplied "as is", without any accompanying services from The Regents. The
% Regents does not warrant that the operation of the program will be
% uninterrupted or error-free. The end-user understands that the program was
% developed for research purposes and is advised not to rely exclusively on
% the program for any reason.
% 
% IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
% DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, INCLUDING
% LOST PROFITS, ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS
% DOCUMENTATION, EVEN IF THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF
% THE POSSIBILITY OF SUCH DAMAGE. THE UNIVERSITY OF CALIFORNIA SPECIFICALLY
% DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
% WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE
% SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
% CALIFORNIA HAS NO OBLIGATIONS TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
% ENHANCEMENTS, OR MODIFICATIONS.


function [coef_vec, v, coef_M]=lerong_corrcoef_vec(f_i_k, x1V, y1V);

tmp=size(f_i_k);
sampleN=tmp(1);
numPt=tmp(2);

vec_length=1;

for i=1:numPt
    coef_M(i,i)=1;
    for j=i+1:numPt        
        v(vec_length)=sqrt((x1V(i)-x1V(j))^2+(y1V(i)-y1V(j))^2);
        coef_tmp=corrcoef(f_i_k(:,i), f_i_k(:,j));
        coef_vec(vec_length)=coef_tmp(1,2);
        coef_vec2(vec_length)=sqrt(coef_tmp(1,1)*coef_tmp(2,2))/mean(f_i_k(:,i))/mean(f_i_k(:,j));
        vec_length=vec_length+1;
        coef_M(i,j) = coef_tmp(1,2);
        coef_M(j,i) = coef_tmp(1,2);
    end
end

eps=5e-7;

figure;
hold on;
for i=1:vec_length-1
    if coef_vec2(i)<eps
        plot(coef_vec2(i),coef_vec(i),'r.');
    else
         plot(coef_vec2(i),coef_vec(i),'b.');
    end
       
end
hold off;