% Copyright  2005-2006 The Regents of the University of California
% All Rights Reserved.
% 
% Permission to use, copy, modify, and distribute this software and its
% documentation for educational, research and non-profit purposes, without
% fee, and without a written agreement is hereby granted, provided that the
% above copyright notice, this paragraph and the following three paragraphs
% appear in all copies.
% 
% Permission to incorporate this software into commercial products may be
% obtained by contacting the University of California, Los Angeles, by
% sending email to lhe@ee.ucla.edu.
% 
% This software program and documentation are copyrighted by The Regents of
% the University of California. The software program and documentation are
% supplied "as is", without any accompanying services from The Regents. The
% Regents does not warrant that the operation of the program will be
% uninterrupted or error-free. The end-user understands that the program was
% developed for research purposes and is advised not to rely exclusively on
% the program for any reason.
% 
% IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
% DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, INCLUDING
% LOST PROFITS, ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS
% DOCUMENTATION, EVEN IF THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF
% THE POSSIBILITY OF SUCH DAMAGE. THE UNIVERSITY OF CALIFORNIA SPECIFICALLY
% DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
% WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE
% SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
% CALIFORNIA HAS NO OBLIGATIONS TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
% ENHANCEMENTS, OR MODIFICATIONS.

function [est_b, est_s, est_sig_g_sqr, est_sig_s_sqr, est_sig_r_sqr, coef_M_spatial]=...
    lerong_var_Decomp(f_i_k, x1V, y1V);

epsilon = 1e-9;

tmp=size(f_i_k);
sampleN=tmp(1);
numPt=tmp(2);



% estimate the total variance

for i=1:numPt    
    sig_tmp(i)=var(f_i_k(:,i));        
end

est_sig_Fchip_sqr = mean(sig_tmp);

% compute the covariance and distance

[coef_vec, v, coef_M_full]=lerong_corrcoef_vec(f_i_k, x1V, y1V);

plot(v,coef_vec,'.');

% use MMSE fitting to estimate the variance and spatial correlation
% functions

rho_s_0=0.3;
rho_g_0=0;
b_0 = 1;
s_0 = 5;
var_s_0 = 10;
par_0 = [var_s_0, rho_g_0, b_0, s_0]';

var_lb = [0.1, -1e-5, 0,  0  ].';
var_up = [0.8, 1e-5, 10, 100].';  


[parOut,resnorm,residual] = lsqcurvefit(@lerong_correlation_fit, ...
    par_0, v, coef_vec, var_lb, var_up);

est_rho_s= parOut(1);
est_rho_g= parOut(2);
est_b    = parOut(3);
est_s    = parOut(4);

est_sig_s_sqr = est_rho_s * est_sig_Fchip_sqr;
est_sig_g_sqr = est_rho_g * est_sig_Fchip_sqr;
est_sig_r_sqr = est_sig_Fchip_sqr - est_sig_s_sqr - est_sig_g_sqr;

coef_M_spatial = (coef_M_full - est_rho_g)/(1-est_rho_g);

coef_M_spatial = adjust_coef_M(coef_M_spatial, epsilon);

%plot(v,coef_vec/est_rho_s,'.');
