% Copyright  2005-2006 The Regents of the University of California
% All Rights Reserved.
% 
% Permission to use, copy, modify, and distribute this software and its
% documentation for educational, research and non-profit purposes, without
% fee, and without a written agreement is hereby granted, provided that the
% above copyright notice, this paragraph and the following three paragraphs
% appear in all copies.
% 
% Permission to incorporate this software into commercial products may be
% obtained by contacting the University of California, Los Angeles, by
% sending email to lhe@ee.ucla.edu.
% 
% This software program and documentation are copyrighted by The Regents of
% the University of California. The software program and documentation are
% supplied "as is", without any accompanying services from The Regents. The
% Regents does not warrant that the operation of the program will be
% uninterrupted or error-free. The end-user understands that the program was
% developed for research purposes and is advised not to rely exclusively on
% the program for any reason.
% 
% IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
% DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, INCLUDING
% LOST PROFITS, ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS
% DOCUMENTATION, EVEN IF THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF
% THE POSSIBILITY OF SUCH DAMAGE. THE UNIVERSITY OF CALIFORNIA SPECIFICALLY
% DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
% WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE
% SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
% CALIFORNIA HAS NO OBLIGATIONS TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
% ENHANCEMENTS, OR MODIFICATIONS.

function [est_b, est_s, est_sig_g_sqr, est_sig_s_sqr, est_sig_r_sqr]=...
    lerong_var_Decomp(f_i_k, x1V, y1V);


tmp=size(f_i_k);
sampleN=tmp(1);
numPt=tmp(2);
sitePt=tmp(2);
datFromChipPtFlag=1;

v=my_compute_v(x1V, y1V);
v=v.';

f_i_k_sqr = f_i_k.^2;
f_sum = sum(sum(f_i_k));
f_sqr_sum = sum(sum(f_i_k_sqr));  
est_sig_F_sqr = (f_sqr_sum - f_sum*f_sum/sampleN/sitePt)/(sampleN*sitePt-1);

f_chip_dot_sum = sum(f_i_k, 2);
f_sqr_chip_dot = sum(f_i_k_sqr, 2);
est_sig_Fchip_sqr = (f_sqr_chip_dot - f_chip_dot_sum.^2/sitePt)/(sitePt-1);
est_sig_Fchip_sqr = sum(est_sig_Fchip_sqr)/sampleN;
est_sig_g_sqr = est_sig_F_sqr - est_sig_Fchip_sqr;

g_sample=f_chip_dot_sum/sitePt;
mean_value = mean(g_sample);

% est_sig_g_sqr = sum((g_sample - mean_value).^2)/(sampleN-1);


% From the measurement data, estimate spatial covariance matrix
f_i_k_sqr = f_i_k.^2;
f_sample_sum = sum(f_i_k);
f_sample_sqr_sum = sum(f_i_k_sqr);







cov_F_i_j = zeros([numPt, numPt]);
for i=1:numPt
    cov_F_i_j(i,i) = (f_sample_sqr_sum(i) - f_sample_sum(i)^2/sampleN)/(sampleN-1) ;
    f_i = f_i_k(:,i);
    for j=i+1:numPt
       f_j = f_i_k(:,j);
       tmp_s_1 = sum(f_i.*f_j)/(sampleN-1);
       tmp_s_2 = f_sample_sum(i)*f_sample_sum(j)/(sampleN*(sampleN-1));
       cov_F_i_j(i,j) = tmp_s_1 - tmp_s_2;
       cov_F_i_j(j,i) = cov_F_i_j(i,j);
    end
end

if(datFromChipPtFlag==1)
  cov_F_vect = myCovM2Vect(cov_F_i_j, x1V, y1V);
else
  cov_F_vect = myCovM2Vect(cov_F_i_j, x_ptN);
end
cov_F_vect_noglb = cov_F_vect - est_sig_g_sqr;

meas_cov_f_i_j = cov_F_vect;  % measured covariance cov(Fi,Fj)
meas_cor_i_j = meas_cov_f_i_j/est_sig_F_sqr; %model correlation coeff


% solving the least square problem to find b, s, and spatial var
noguess = 1;
if(noguess==1)
  b_0 = 1;
  s_0 = 5;
  var_s_0 = 10;
  par_0 = [var_s_0, b_0, s_0]';
end
% msg = sprintf('Underlying: b=%f, s=%f, var_s=%f', b, s, var_s);
% disp(msg);
% msg = sprintf('InitGuess: b=%f, s=%f, var_s=%f', b_0, s_0, var_s_0);
% disp(msg);
var_s_lb = 0.0000001;  % only the first par in par_0 gets the bound constraint
var_s_up = est_sig_Fchip_sqr;  
[parOut,resnorm,residual] = lsqcurvefit(@mySpatialCovarianceFittingFunc, ...
    par_0, v, cov_F_vect_noglb,var_s_lb,var_s_up);
msg = sprintf('Final: b=%f, s=%f, var_s=%f', parOut(2), parOut(3), parOut(1));
disp(msg);
est_sig_s_sqr = parOut(1);
est_b         = parOut(2);
est_s         = parOut(3);
est_sig_r_sqr = est_sig_F_sqr - est_sig_g_sqr - est_sig_s_sqr; % estimate random variation component


