% Copyright  2005-2006 The Regents of the University of California
% All Rights Reserved.
% 
% Permission to use, copy, modify, and distribute this software and its
% documentation for educational, research and non-profit purposes, without
% fee, and without a written agreement is hereby granted, provided that the
% above copyright notice, this paragraph and the following three paragraphs
% appear in all copies.
% 
% Permission to incorporate this software into commercial products may be
% obtained by contacting the University of California, Los Angeles, by
% sending email to lhe@ee.ucla.edu.
% 
% This software program and documentation are copyrighted by The Regents of
% the University of California. The software program and documentation are
% supplied "as is", without any accompanying services from The Regents. The
% Regents does not warrant that the operation of the program will be
% uninterrupted or error-free. The end-user understands that the program was
% developed for research purposes and is advised not to rely exclusively on
% the program for any reason.
% 
% IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
% DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, INCLUDING
% LOST PROFITS, ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS
% DOCUMENTATION, EVEN IF THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF
% THE POSSIBILITY OF SUCH DAMAGE. THE UNIVERSITY OF CALIFORNIA SPECIFICALLY
% DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
% WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE
% SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
% CALIFORNIA HAS NO OBLIGATIONS TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
% ENHANCEMENTS, OR MODIFICATIONS.


%function myVarDecompTable
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Robust Extraction of Spatial Correlation
%%   -by Jinjun Xiong (jinjun@ucla.edu)
%% -released on 05/30/3006
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%inputSample = [2000];
%inputNoiseRatio = [0.5];
runFlag = 1;
tabFlag_sample = 0;
siteFlag = 1;
tabFlag_site = 0;

if runFlag==1
inputSample = [2000 1500 1000 500];
inputNoiseRatio = [0.1 0.5 1];
siteN = 60;
Mtab = zeros(length(inputSample)*length(inputNoiseRatio),4);
idx = 1;
for i=1:length(inputSample)
    sampleN = inputSample(i);
    for j=1:length(inputNoiseRatio)
        noiseR = inputNoiseRatio(j);
        [per_g_err, per_s_err, per_r_err, per_rho_err]=myVarDecomp(sampleN, noiseR, siteN);
        Mtab(idx,:) = [per_g_err, per_s_err, per_r_err, per_rho_err];
        idx = idx+1;
    end
end
end
% print out the sample table in latex format

if tabFlag_sample ==1
inputSample = [2000 1500 1000 500];
inputNoiseRatio = [0.1 0.5 1];
siteN = 60    
idx = 1;
for i=1:length(inputSample)
    sampleN = inputSample(i);
%    fprintf('\\multicolumn{4}{|c|}{%d}\\\\ \n', sampleN);
%    fprintf('\\hline\n');
    fprintf('%d & %d &', sampleN, siteN);
    for j=1:length(inputNoiseRatio)
        noiseR = inputNoiseRatio(j);
        per_g_s_r_rho_err = Mtab(idx,:)*100;
        if(j==1)
            fprintf('%d\\%% & %.1f\\%% & %.1f\\%% & %.1f\\%% \\\\ \n', ...
                noiseR*100, per_g_s_r_rho_err(1), per_g_s_r_rho_err(2), per_g_s_r_rho_err(4));
        else
            fprintf('& & %d\\%% & %.1f\\%% & %.1f\\%% & %.1f\\%% \\\\ \n', ...
                noiseR*100, per_g_s_r_rho_err(1), per_g_s_r_rho_err(2), per_g_s_r_rho_err(4));
        end
        if(j<length(inputNoiseRatio))
            fprintf('\\cline{3-6}\n');
        else
            fprintf('\\hline \n');
        end
        idx = idx+1;
    end
end
end


if siteFlag==1
inputSample = [1000];
inputNoiseRatio = [0.1 0.5 1];
inputSiteNum = [50 40 30 20 10];
Msitetab = zeros(length(inputSample)*length(inputNoiseRatio)*length(inputSiteNum),4);
idx = 1;
for i=1:length(inputSample)
    sampleN = inputSample(i);
    for j=1:length(inputSiteNum)
        siteN = inputSiteNum(j);
        for k=1:length(inputNoiseRatio)
            noiseR = inputNoiseRatio(k);
            [per_g_err, per_s_err, per_r_err, per_rho_err]=myVarDecomp(sampleN, noiseR, siteN);
            Msitetab(idx,:) = [per_g_err, per_s_err, per_r_err, per_rho_err];
            idx = idx+1;
        end
    end
end
end

% print out the site table in latex format

if tabFlag_site ==1
inputSample = [1000];
inputNoiseRatio = [0.1 0.5 1];
inputSiteNum = [50 40 30 20 10];
idx = 1;
for i=1:length(inputSample)
    sampleN = inputSample(i);    
    fprintf('%d &', sampleN);
    for j=1:length(inputSiteNum)
        siteN = inputSiteNum(j);
        if(j==1)
            fprintf('%d &', siteN);
        else
            fprintf('& %d &', siteN);
        end
        
        for k=1:length(inputNoiseRatio)
            noiseR = inputNoiseRatio(k);
            per_g_s_r_rho_err = Msitetab(idx,:)*100;
            if(k==1)
                fprintf('%d\\%% & %.1f\\%% & %.1f\\%% & %.1f\\%% \\\\ \n', ...
                    noiseR*100, per_g_s_r_rho_err(1), per_g_s_r_rho_err(2), per_g_s_r_rho_err(4));
            else
                fprintf('& & %d\\%% & %.1f\\%% & %.1f\\%% & %.1f\\%% \\\\ \n', ...
                    noiseR*100, per_g_s_r_rho_err(1), per_g_s_r_rho_err(2), per_g_s_r_rho_err(4));
            end
            if(k<length(inputNoiseRatio))
                fprintf('\\cline{3-6}\n');
            else
                fprintf('\\cline{2-6}\n');
            end
            idx = idx+1;
        end
        if(j==length(inputSiteNum))
            fprintf('\\hline \n');
        end
    end    
end
end
        

        
