% Copyright  2005-2006 The Regents of the University of California
% All Rights Reserved.
% 
% Permission to use, copy, modify, and distribute this software and its
% documentation for educational, research and non-profit purposes, without
% fee, and without a written agreement is hereby granted, provided that the
% above copyright notice, this paragraph and the following three paragraphs
% appear in all copies.
% 
% Permission to incorporate this software into commercial products may be
% obtained by contacting the University of California, Los Angeles, by
% sending email to lhe@ee.ucla.edu.
% 
% This software program and documentation are copyrighted by The Regents of
% the University of California. The software program and documentation are
% supplied "as is", without any accompanying services from The Regents. The
% Regents does not warrant that the operation of the program will be
% uninterrupted or error-free. The end-user understands that the program was
% developed for research purposes and is advised not to rely exclusively on
% the program for any reason.
% 
% IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
% DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, INCLUDING
% LOST PROFITS, ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS
% DOCUMENTATION, EVEN IF THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF
% THE POSSIBILITY OF SUCH DAMAGE. THE UNIVERSITY OF CALIFORNIA SPECIFICALLY
% DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
% WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE
% SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
% CALIFORNIA HAS NO OBLIGATIONS TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
% ENHANCEMENTS, OR MODIFICATIONS.

function [f_i_k, x1V, y1V]=my_data_proc(read_data);

% process the read in data and return the measurement data and the
% within locations 

num_samples=length(read_data);
num_sites=1;
num_dies =1;

x1V(1)=read_data(1).within_die_loc_x;
y1V(1)=read_data(1).within_die_loc_y;

die_id(1).wafer_id              =read_data(1).wafer_id;
die_id(1).die_in_wafer_loc_x   =read_data(1).die_in_wafer_loc_x;
die_id(1).die_in_wafer_loc_y   =read_data(1).die_in_wafer_loc_y;
% die_id(1).lot_id                =read_data(1).lot_id;

for i_sample=1:num_samples
    
    [num_sites num_dies x1V y1V die_id site_index die_index]=...
        detect_data(num_sites, num_dies, x1V, y1V, die_id, read_data(i_sample));    
    
    f_i_k(die_index, site_index)=read_data(i_sample).Quantity;
    
end % end loop i_pt


